// gcc -o trsv.x -Wall -L/Users/pauldj/worksG/libsG/OpenBLAS/ -lopenblas my-trsv.c


#include <stdlib.h>
#include <stdio.h> 


int dtrsv_( char *, char *, char *, int *, double *, int *, double *, int * );



int main( int argc, char *argv[] )
{
  int n, i, j;
  double *L, *y;
   
  if(argc == 1){ printf(" argument needed: pass me one argument\n"); return(-1);}
  if(argc > 1)  n = atoi(argv[1]);

  L = (double *) malloc( n * n * sizeof(double) );
  y = (double *) malloc( n * sizeof(double) );

  /*
   1 
   2 3
   5 6 7
   . . . . 
   . . . . i^2 + j + 1    
   */

  for( i=0; i<n; i++ )     //row
     for( j=0; j<n; j++ )      //column    //the order does not matter!
	if( j <= i ){
	   printf(" index: %d\t value: %d\n", i+j*n, i*i + j + 1);
	   L[ j + i*n ]  =i*i + j + 1;     //this is what matters!
	}
	else
	   L[ j + i*n ] = 0;
  
  for( i=0; i<n; i++ ) y[ i ] = 1; 


  FILE *output;
  //output = fopen("mfile.m", "w");
  output = stdout;

  fprintf(output, "L = [ ...\n" );
  for( i=0; i<n; i++ ) //row
    {
      for( j=0; j<n; j++ )  //column
	fprintf(output, "%g ", L[j+i*n] );
      fprintf(output, "; ...\n" );
    }
  fprintf(output, "];\n" );


  fprintf(output, "y = [ ...\n" );
  for( j=0; j<n; j++ )  
    fprintf(output, "%g; ...\n ", y[j] );
  fprintf(output, "];\n" );

  char uplo = 'L';
  char trans = 'N';
  int incy = 1;

  dtrsv_( &uplo, &trans, "N", &n, L, &n, y, &incy );

  fprintf(output, "x = [ ...\n" );
  for( j=0; j<n; j++ )  
    fprintf(output, "%.16g; ...\n ", y[j] );
  fprintf(output, "];\n" );

  // check the results! Are they correct? 

  free( L );
  free( y );

  return( 0 );
}

